config/routes.rb
#     Copyright 2016 Netflix, Inc.
#
#     Licensed under the Apache License, Version 2.0 (the "License");
#     you may not use this file except in compliance with the License.
#     You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
#     Unless required by applicable law or agreed to in writing, software
#     distributed under the License is distributed on an "AS IS" BASIS,
#     WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#     See the License for the specific language governing permissions and
#     limitations under the License.

require 'sidekiq/web'

class ActionDispatch::Routing::Mapper
  def draw_custom
    ["custom/config/routes.rb", "../custom/config/routes.rb"].each do |filename|
      instance_eval(File.read(Rails.root.join(filename))) if File.file?(filename)
    end
    
  end
end

Scumblr::Application.routes.draw do

  draw_custom

  if(User.devise_modules.include?(:omniauthable))
    devise_for :users , :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }
    match '/users/auth/openid_connect/callback' => 'users/omniauth_callbacks#openid_connect_callback', via: [:get, :post]
    match '/users/auth/openid_connect' => 'users/omniauth_callbacks#openid_connect', via: [:get, :post], as: "openid_connect"
  else
    devise_for :users
  end

  resources :users do
    member do
      post 'toggle_admin'
    end
  end

  resources :system_metadata
  resources :events, only: [:index, :show] do
    collection do
      post 'search' => 'events#index'
      get 'search' => 'events#index'
    end

  end
  resources :flags

  get "user_saved_filters/create"
  get "user_saved_filters/destroy"
  get "saved_filters/new"
  get "saved_filters/destroy"

  resources :saved_filters do
    member do
      post :add
      post :remove
    end
  end



  resources :results do
    collection do
      post 'update_multiple'
      post 'bulk_add'
      post 'search' => 'results#index'
      get 'search' => 'results#index'
      get 'tags/:tag', to: 'results#index', as: :tag
      get 'dashboard'
      get 'workflow_autocomplete'
      post 'update_table_columns'

      get 'expandall', to: 'results#expandall'
      get 'show', to: 'results#show', as: :show_by_name
      get 'expandvulns', to: 'results#expandvulns'
      get 'expandclosedvulns', to: 'results#expandclosedvulns'
      post 'create_vulnerability', to: 'results#create_vulnerability'
    end

    member do
      post 'change_status/:status_id'=>"results#update_status", as: 'update_status'
      post 'comment'  => 'results#comment', :as=> :comment
      post 'tag'  => 'results#tag'
      post 'flag'  => 'results#flag'
      post 'action/:result_flag_id/step/:stage_id'  => 'results#action', as: 'action'
      post 'assign'  => 'results#assign'
      post 'subscribe'  => 'results#subscribe'
      post 'unsubscribe'  => 'results#unsubscribe'
      delete 'tags/:tag_id', to: 'results#delete_tag', as: :delete_tag
      post :add_attachment
      delete 'attachment/:attachment_id', to: 'results#delete_attachment', as: :delete_attachment
      post 'generate_screenshot' => "results#generate_screenshot"
      post 'update_screenshot'
      get 'update_screenshot'
      match 'update_metadata', via: [:get, :post]
      match 'get_metadata', via: [:get, :post]
      get 'summary', to: 'results#summary'
      
      match 'render_metadata_partial', via: [:get, :post]
    end


  end

  resources :tags, only: :index

  resources :tasks do
    collection do
      get 'options', to: 'task_types#options'
      get 'run', to: 'tasks#run'
      post 'bulk_update'
      get 'expandall', to: 'tasks#expandall'
      get :events
    end


    member do
      get 'run', to: 'tasks#run'
      get 'get_metadata'
      post 'enable', to: 'tasks#enable'
      post 'disable', to: 'tasks#disable'
      get 'summary', to: 'tasks#summary'

    end

    member do
      get 'options', to: 'task_types#options'
    end
  end

  resources :statuses do
    member do
      post 'set_default'
    end
  end

  get 'status', to: 'status#status'
  get 'about', to: 'status#about'

  root to: "results#index"

  admin_constraint = lambda do |request|
    request.env['warden'].authenticate? && request.env['warden'].user.admin?
  end

  constraints admin_constraint do
    mount Workflowable::Engine => "/workflowable", as: :workflowable
    mount Sidekiq::Web => '/sidekiq'
    get 'errors', :to => "event_groups#index"
    get 'about', to: 'status#about'
  end

end

app/views/shared/_abstract_collapse.html.erb
<%= render :layout=>"shared/collapse", :locals => {:title=>"#{result_set[:name]} (#{instance_variable_get("@#{result_set[:method]}_count")})", :paginated_array=>instance_variable_get("@#{result_set[:method]}_paginated"), :remote=>true, :action_name=>"#{result_set[:method]}"} do %>
  <thead>
    <tr>
      <% if result_set[:link] %>
        <th><%= result_set[:link][:method].to_s.titlecase %></th>
      <% end %>
      <% result_set[:attributes].each do |a| %>
        <th><%= a.to_s.titlecase %></th>
      <% end %>
    </tr>
  </thead>
  <tbody>
    <% instance_variable_get("@#{result_set[:method]}_paginated").each do |i| %>
      <tr>
        <% if result_set[:link] %>
          <td><%= link_to i.send(result_set[:link][:method]), send(result_set[:link][:path], *result_set[:link][:params].map{|f| i.send(f)}) %></td>
        <% end %>
        <% result_set[:attributes].each do |a| %>
          <td><%= i.send(a) %></td>
        <% end %>
      </tr>
    <% end %>
  </tbody>
<% end %>

app/views/shared/_abstract_table.html.erb
<% 
  if(result_set[:object].class == Array && result_set[:object].first.class == Hash)
    sort = nil
    begin 
      sort = Integer(params[:sort])
      sort -= 1
    rescue

    end
    object = result_set[:object]


    if(sort && result_set[:sort_keys][sort])
      sort_key = result_set[:sort_keys][sort]
      object =  object.sort{|a,b| a.try(:[], sort_key) <=> b.try(:[], sort_key)}

      if(params[:sort_dir] == "desc")
        object.reverse!
      end
    end
    object = Kaminari.paginate_array(object).page(params[:page] || 1).per(params[:per_page] || 25) 
    instance_variable_set("@#{result_set[:method]}_paginated", object)
  end
  
   
%>

<% uuid = params[:uuid] || SecureRandom.hex %>
<% result_set[:sort_keys] ||= [] %>
<%= render :layout=>"shared/paginated_table", :locals => {:title=>"#{result_set[:name]} (#{instance_variable_get("@#{result_set[:method]}_count")})", :paginated_array=>instance_variable_get("@#{result_set[:method]}_paginated"), :remote=>true, :action_name=>"#{result_set[:method]}", :uuid=> uuid} do %>
  <thead>
    <tr>
      <% if result_set[:link] %>
        <th>
          <% if result_set[:link][:sort_key] %>
            <% dir = (params[:sort].to_i == 0 && params[:sort_dir] == 'asc') ? :desc : :asc %>
            <% title = CGI::escapeHTML((result_set[:link][:label] || result_set[:link][:method]).to_s.titlecase) %>
            <% if params[:sort].to_i ==  0 && params[:sort_dir] == 'asc' %>
              <% dir = :desc %>
              <% title += " &#x25b2" %>
            <% elsif params[:sort].to_i == 0 && params[:sort_dir] == 'desc' %>
              <% title += " &#x25bc" %>
            <% end %>
            <%= link_to title.html_safe, params.merge({:action_name => result_set[:method], sort: 0, :remote=> true, :sort_dir => dir, uuid: uuid}) %>
          <% else %>
            <%= result_set[:link][:method].to_s.titlecase %>
          <% end %>
        
          

        </th>

      <% end %>
      <% result_set[:attributes].each_with_index do |a,i| %>
        
        
        <th>
          <% if result_set[:labels].try(:[],i) %>
            <% title = CGI::escapeHTML(result_set[:labels].try(:[],i).to_s.titlecase) %>
          <% else %>
            <% title = CGI::escapeHTML(a.to_s.titlecase) %>
          <% end %> 
          
          <% if(result_set[:sort_keys] && result_set[:sort_keys][i]) %>
            
            <% dir = :asc %>
            <% if params[:sort].to_i ==  i+1 && params[:sort_dir] == 'asc' %>
              <% dir = :desc %>
              <% title += " &#x25b2" %>
            <% elsif params[:sort].to_i ==  i+1 && params[:sort_dir] == 'desc' %>
              <% title += " &#x25bc" %>
            <% end %>
            <%= link_to title.html_safe, params.merge({:action_name => result_set[:method], sort: i+1, :remote=> true, :sort_dir => dir, uuid: uuid}) %>

          <% else %>
            <%= title %>
          <% end %>
          
        </th>
      <% end %>
      <% if result_set[:actions] %>
        <% result_set[:actions].each_with_index do |a,i| %>
          <th></th>
        <% end %>
      <% end %>
    </tr>
  </thead>
  <tbody>
    <% (instance_variable_get("@#{result_set[:method]}_paginated") || []).each do |i| %>
      <tr>
        <% if result_set[:link] %>
        
        
          <td><%= link_to i.send(result_set[:link][:method]), send(result_set[:link][:path], *result_set[:link][:params].map{|f| i.send(f)}) %></td>
        
        <% end %>
        <% result_set[:attributes].each_with_index do |a, index| %>
          <td>
          <% if i.class == Hash %>
            <% data = i.send(:[], a) %>
          <% else %>
            <% data = i.send(a) %>
          <% end %>
          <% if(result_set.try(:[],:formatters).try(:[],index)) %>

            <% data = send(result_set.try(:[],:formatters).try(:[],index), data) %>

          <% end %>
          <% if result_set[:include_link].try(:[],index) && data.class.methods.include?(:model_name) %>
            <% begin %>
              <%= link_to data, url_for(data) %>
            <% rescue %>
              <%= data %>  
            <% end %>
          <% else %>
            <%= data %>
          <% end %> 
           
          </td>
        <% end %>
        <% if result_set[:actions] %>
          <% result_set[:actions].each_with_index do |a, index| %>
            <td><%= link_to a[:label].to_s,  send(a[:path], *a[:params].map{|f| i.send(f)}), confirm:a[:confirm]||false, method: a[:method]||:get %>

            </td>
          <% end %>
        <% end %>
      </tr>
    <% end %>
  </tbody>
<% end %>

app/views/shared/_ajax_error.js.erb
<% if @notice.present? %>
  $('#flash_messages').html("<%= escape_javascript(render :partial=>"shared/notification", :locals => {:message=>@notice}) %>");
<% end %>





ready();


hide_preloader();
$("#preloader-modal").foundation('reveal','close');

app/views/shared/_ajax_metadata_accordion.html.erb
<% options ||= {} %>
<% accordion_id = options[:accordion_id] || SecureRandom.hex %>
<% extra_params = options[:extra_params] || {} %>
<dl class="accordion" data-accordion>
  <dd class="accordion-top-navigation">
    <%= link_to render_metadata_partial_result_path({id: result.id, partial: partial_name, target: "#partial_#{accordion_id}"}.merge(extra_params)), :id =>"partial_#{accordion_id}", :remote=>true do %>
      <%= title %>
      <% if options[:include_refresh] == true %>
        <%= button_to "Refresh", render_metadata_partial_result_path(id: @result.id, partial: partial_name, target: "#partial_#{accordion_id}"), :form_class=> "inline", :method=>"get", :class=>"refresh hidden button tiny right", :remote=>true %>
      <% end %>
      <%= yield :title_content %>
      <% content_for :title_content, flush: true do "" end %>
    <% end %>

    <%= yield :before_accordion_content %>
    <% content_for :before_accordion_content, flush: true do "" end %>

    

    <div class="panel content" id="<%= "partial_#{accordion_id}_container"%>">
      <%= yield :pre_content %>
      <% content_for :pre_content, flush: true do "" end %>

      <div id="<%= "partial_#{accordion_id}_content"%>">
      </div>

      <%= yield :post_content %>
      <% content_for :post_content, flush: true do "" end %>
    </div>
    
    
  </dd>
</dl>

app/views/shared/_collapse.html.erb
<% uuid= params[:uuid] || SecureRandom.uuid %>
<% if request.format != "application/javascript" %>
  <dl class="accordion" data-accordion>
    <dd>
      <a href="#panel_<%= uuid -%>"><%= title -%></a>
      <div id="panel_<%= uuid -%>" class="content">
      <% end %>
      <%= render layout: 'shared/paginated_table', locals:local_assigns.reverse_merge({uuid:uuid})  do %>
        <%= yield %>
      <% end %>
      <% if request.format != "application/javascript" %>
      </div>
    </dd>
  </dl>
<% end %>

app/views/shared/_comment.html.erb
<div class="comment clearfix">
  <div class="comment_main">
    <div class="comment_head">
      [<%= link_to "-", "#", :class=>"toggle_comment" %>]
      <%= comment.user %>
      <small><%= time_ago_in_words(comment.created_at) %>
        ago</small>
    </div>
    <div class="comment_contents">
      <div class="comment_body">
        <p><%= comment.body %></p>
      </div>
      <div class="comment_buttons">
        <%= link_to "Reply", "#", :class=>"reply button tiny", "data-parent_id"=>comment.id %>
      </div>
      <div class="comment_reply" >&nbsp;</div>
      <% comment.children.each do |child| %>
        <div class="child">
          <%= render "shared/comment", :comment=>child %>
        </div>
      <% end %>
    </div>
  </div>
</div>

app/views/shared/_key_value_table.html.erb
<table>
  <tbody>
  <% result_set[:keys].each_with_index do |k,i| %>
    <tr>
      <td class="header"><%= result_set.try(:[],:labels).try(:[],i) || k.to_s.titleize %></td>
      <td>
        <% data = result_set[:object].send(k) %>
          <% if result_set[:include_link].try(:[],i) && data.class.methods.include?(:model_name) %>
            <% begin %>
              <%= link_to data, url_for(data) %>
            <% rescue %>
              <%= data %>  
            <% end %>
          <% else %>
            <%= data %>
          <% end %> 
      </td>
    </tr>
  <% end %>
  </tbody>
</table>

app/views/shared/_notification.html.erb
<% Array(message).each do |msg| %>
  <div data-alert class="alert-box">
    <%= msg %>
    <a href="#" class="close">&times;</a>
  </div>
<% end %>

app/views/shared/_paginated_table.html.erb
<% if !defined? uuid %>
  <% uuid= params[:uuid] || SecureRandom.uuid %>
<% end %>
<div id="div_<%= uuid -%>" >
  <table class="table " id="table_<%= uuid -%>">
    <%= yield %>
  </table>
  <% if defined? paginated_array %>
    <% extra_params = {uuid: uuid} %>
    <% extra_params[:action] = action if defined? action %>
    <% extra_params[:action_name] = action_name if defined? action_name %>
    <%= paginate paginated_array, :outer_window => 3, :window=>1, :remote=> (defined? remote)? remote : false, :params => extra_params if paginated_array.methods.include?(:current_page) %>
  <% end %>
</div>

app/views/shared/_trend_charts.html.erb
<% trend_data.each do |k,v| %>
<div class="chart">

  <% if v.try(:[],"data").count > 1 %>
    <%= column_chart v["data"], stacked: true, library: {title: {display:true, text: k.titleize}}.merge(v["library"] || {}) %>
  <% else %>
    <%=line_chart v["data"], library: {title: {display:true, text: k.titleize}}.merge(v["library"] || {}) %>
    
    
  <% end %>
</div>
<% end %>